#include <stdlib.h>
#include <string.h>

#include "file_node.h"
#include "file_descriptor.h"

struct _FileDescriptor {
  file_descriptor_mode_t mode;
  int offset;
  FileNode node;
};

file_descriptor_mode_t FileDescriptor_GetMode(FileDescriptor fdesc)
{
  return fdesc->mode;
}

file_descriptor_mode_t FileDescriptor_SetMode(FileDescriptor fdesc,
					      file_descriptor_mode_t mode)
{
  return fdesc->mode = mode;
}

int FileDescriptor_GetOffset(FileDescriptor fdesc)
{
  return fdesc->offset;
}

int FileDescriptor_SetOffset(FileDescriptor fdesc, int offset)
{
  return fdesc->offset = offset;
}

int FileDescriptor_AddOffset(FileDescriptor fdesc, int offset)
{
  return fdesc->offset += offset;
}

FileNode FileDescriptor_GetNode(FileDescriptor fdesc)
{
  return fdesc->node;
}

FileNode FileDescriptor_SetNode(FileDescriptor fdesc, FileNode node)
{
  return fdesc->node = node;
}

FileDescriptor FileDescriptor_Create(file_descriptor_mode_t mode, FileNode node)
{
  FileDescriptor fdesc;

  fdesc = malloc(sizeof(*fdesc));

  memset(fdesc, 0, sizeof(*fdesc));

  fdesc->mode   = mode;
  fdesc->offset = 0;
  fdesc->node   = node;

  return fdesc;
}

FileDescriptor FileDescriptor_Destroy(FileDescriptor fdesc)
{
  if (fdesc)
    free(fdesc);
  return NULL;
}
