#ifndef __FILE_DESCRIPTOR_H_INCLUDED__
#define __FILE_DESCRIPTOR_H_INCLUDED__

#include "file_node.h"

typedef enum {
  FILE_DESCRIPTOR_MODE_READONLY,
  FILE_DESCRIPTOR_MODE_READWRITE,
} file_descriptor_mode_t;

typedef struct _FileDescriptor *FileDescriptor;

file_descriptor_mode_t FileDescriptor_GetMode(FileDescriptor fdesc);
file_descriptor_mode_t FileDescriptor_SetMode(FileDescriptor fdesc,
					      file_descriptor_mode_t mode);
int FileDescriptor_GetOffset(FileDescriptor fdesc);
int FileDescriptor_SetOffset(FileDescriptor fdesc, int offset);
int FileDescriptor_AddOffset(FileDescriptor fdesc, int offset);
FileNode FileDescriptor_GetNode(FileDescriptor fdesc);
FileNode FileDescriptor_SetNode(FileDescriptor fdesc, FileNode node);
FileDescriptor FileDescriptor_Create(file_descriptor_mode_t mode, FileNode node);
FileDescriptor FileDescriptor_Destroy(FileDescriptor fdesc);

#endif
