#ifndef __FILE_NODE_H_INCLUDED__
#define __FILE_NODE_H_INCLUDED__

#include "block.h"
#include "file_object.h"

typedef struct _FileNode *FileNode;

/******** for FileNode operation ********/

unsigned int FileNode_GetFlags(FileNode node);
unsigned int FileNode_SetFlags(FileNode node, unsigned int flags);
int FileNode_GetUserID(FileNode node);
int FileNode_SetUserID(FileNode node, int id);
int FileNode_GetGroupID(FileNode node);
int FileNode_SetGroupID(FileNode node, int id);
int FileNode_GetAccessTime(FileNode node);
int FileNode_SetAccessTime(FileNode node, int t);
int FileNode_SetAccessTimeNow(FileNode node);
int FileNode_GetModifiedTime(FileNode node);
int FileNode_SetModifiedTime(FileNode node, int t);
int FileNode_SetModifiedTimeNow(FileNode node);
int FileNode_GetChangedTime(FileNode node);
int FileNode_SetChangedTime(FileNode node, int t);
int FileNode_SetChangedTimeNow(FileNode node);
BlockPool FileNode_GetPool(FileNode node);
FileObject FileNode_GetObject(FileNode node);
FileObject FileNode_SetObject(FileNode node, FileObject object);
FileObject FileNode_ResetObject(FileNode node);
FileNode FileNode_Create(BlockPool pool, const char *name);
FileNode FileNode_Destroy(FileNode node);

/******** for FileName operation ********/

int FileNode_NameGetSize(FileNode node);
int FileNode_NameRead(FileNode node, int size, char *buffer);
int FileNode_NameWrite(FileNode node, const char *buffer);
int FileNode_NameCompare(FileNode node, const char *buffer);

#endif
